% FORMAT of the geometry file
% S -- shot
% R -- rec
%
% column           1        2      3   4   5   6        7
% meaning     ( S_index  R_index  Sx  Sz  Rx  Rz  S_is_alive(0/1) )

clear all; 
clc;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% source param
ns = 117;              % number of shots
ds = 2.0;            % shot interval

os = 1.0;            % origin of 1st shot
zs = 0.0;             % shot depth
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% receiver param
nr = 117;             % number of recs
dr = 2.0;             % rec interval

or = 1.0;            % origin of 1st rec
zr = 0.0;             % rec depth
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

geom=zeros(nr*ns,7);
geom(:,4)=zs;    % vertical coordinates of sources
geom(:,6)=zr;    % vertical coordinates of receivers
geom(:,7)=1.0;   % the last column, always 1 if source is alive

for is=1:ns
    s_off = ds*(is-1);
    sx    = os + s_off;
    for ir=1:nr
        rx = or + dr*(ir-1);%+s_off;
        ig = ir + nr*(is-1);
        geom(ig,[1 2 3 5])=[is ir sx rx];
    end
end

fid=fopen('coord2d_wadi.txt','wt');
fprintf(fid,'%6i %6i %10.1f %10.1f %10.1f %10.1f %10.1f\n',geom');
%%%%%%%%%%%%%%%%%%%%%%%%%%
% coordfile = strcat('coord2d_shot',num2str(is),'.txt');
% fid = fopen(coordfile,'wt');
% fprintf(fid,'%6i %6i %10.1f %10.1f %10.1f %10.1f %10.1f\n', ...
%     (geom((is-1)*nr+1:(is*nr), :))');%save a single shot
%%%%%%%%%%%%%%%%%%%%%%%%%%
fclose(fid);
