load 'Wadi_Qudaid_1.mat';
% wq=csg;

dim = size(csg);
disp(dim);
nt = dim(1);
ns = dim(2);
ng = dim(3);
% wq = reshape(csg, nt, ng, ns);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
wq = zeros([nt  ng  ns]);

data = zeros([nt ng]);
trace = zeros([nt 1]);
data(:, :) = csg(:, :, 70);

% figure;
% imagesc( data, [-15 15]);
% colormap( gray );

% figure;
% trace = data( :, 85 )/10;
% plot(1:nt, trace);
% grid on;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% compare traces for one csg
% numsubplot = 5;
% figure;
% for i = 1:numsubplot
%     trace = data(:, i*5+50);
%     subplot(numsubplot,1,i);
%     plot(1:nt, trace);
% %     axis([1 250 -5500 5500]);
%     hold on;
% end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Extracting Early arrivals
figure;
farr = readbin('processed_pick.bin',ns,ng);
imagesc(farr);
dwin = zeros([ns 2*ng]);
dynwin = 35;  % around 35dt+20=0.055s, which is about 3~4 periods of the wavelet
for i = 1:ns
    srcarr = floor(farr(i,i)/0.001)-5;
    for j = 1:ng                 
        t1  = floor(farr(i,j)/0.001)+1;        
        t2  = t1  + dynwin;        
        %%%%%%%%%%%%%%%%%%%
        for stop = 1:20
            if( csg(t1+dynwin, j, i) * csg(t1+dynwin+stop, j, i)<=0 )
                t2 = t1 + dynwin + (stop-1);
                break;
            end
        end
        disp('stop ='); disp(stop);
        %%%%%%%%%%%%%%%%%%%
        t11 = t1 - srcarr;
        if( t11 < 1 )
            t11 = 1;
        end
        t22 = t11 + (t2-t1);        
        wq(t11:t22, j, i) = csg(t1:t2, j, i);
        
%         dwin(j+(i-1)*ns, 1) = i;
%         dwin(j+(i-1)*ns, 2) = j;
        dwin(i, 2*(j-1)+1) = 1+(t11-1)*8;
        dwin(i, 2*(j-1)+2) = 1+(t22-1)*8;        
    end
    disp('i ='); disp(i);
    disp(farr(i,i));
end
writebin('wadi_data_window.bin',dwin);

figure;
data( :, : ) = wq(:, :, 70);
subplot( 211 );
imagesc( data );
colormap(gray);
title('CSG #70');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% OBS windowed early arrival dataset
ext_trace = zeros([nt*8-7 1]);
ext_data = zeros([nt*8-7 ng]);

for is=1:ns
    path = strcat('./OBS/wadi',num2str(is),'.bin');
    for ig=1:ng
        trace(:) = wq(:,ig,is);        % select each trace
        trace = trace/max(abs(trace)); % trace by trace normalization
        for it = 1:nt
            ext_trace(1+(it-1)*8) = trace(it);
            if(it<nt)
                for k = 1:1:7
                    lam = 0.125*k;
                    ext_trace(1+(it-1)*8+k) = (1-lam)*trace(it)+(lam)*trace(it+1);
                end
            end
        end
        ext_data(:,ig) = ext_trace(:);
    end
    writebin( path, ext_data(1:2000, :) );
end

subplot(212);
trace(:) = wq(:, 94, 17);         % get one trace
trace    = trace/max(abs(trace)); % normalization
plot(1:nt, trace);
title('Trace, is = 17, ig = 94');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Making source
% is = 53;
% ig = 58;
% data(:, :) = csg(:, :, is);
% it1 = round(farr(is,ig)/0.001);
% disp('it1=');disp(it1);
% it2 = it1+7;
% trace      = 0.0 * trace;
% for stop = 1:20
%     if(data(it2,ig)*data(it2+stop,ig)<=0)        
%         break;
%     end;
% end;
% it2 = it2+stop;
% trace( 5: 5+abs(it2-it1)) = data( it1:it2, ig );
% % trace = trace /max(abs(trace));
% 
% ext_trace = 0.0 * ext_trace;
% for it = 1:nt
%     ext_trace(1+(it-1)*8) = trace(it);
%     if(it<nt)
%         for k = 1:1:7
%             lam = 0.125*k;
%             ext_trace(1+(it-1)*8+k) = (1-lam)*trace(it)+(lam)*trace(it+1);
%         end;
%     end;
% end; 
% ext_trace = ext_trace/max(abs(ext_trace));
% 
% subplot(313);
% plot( 1:8*nt-7, ext_trace );
% hold on;
% axis([0 1000 -1 1]);
%%%%%%%%
% writebin( 'natsrc.bin', ext_trace(1:2000) );
% figure;
% plot(1:nt,csg(:,ig,is));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%