! module for defining data structures
!
module datatype

type param
  integer            :: nx, nz, nt, nt_in, shift_wavefield, free_surface, itermax, variable_density, &
                        precondition, skipshot, skiptrace, npml, mute_data, ismarine, mute_directwave, &
                        normalize, line_search, smooth, method, exportwavefield, nt_out, izwb, &
                        smoothgrad, smoothvel
  real               :: dx, dt, f, dt_out, cmin, cmax, vmin, vmax, step, xmin, xmax, offset_min, offset_max, &
                        window, dt_in, &
                        vconstraint                 ! Velocity update constraint in percentage
  character(len=100) :: velfile, velfile_out, coordfile, fileformat, csg_out, topofile, sourcefile, &
                        sourcetype, csg_in, logfile, data, residualfile, waterbottomfile, velfile_bg, &
                        densityfile, vpfile, vsfile
end type param

type acquisition
  ! Data format: t(is,ig), xg(iz,ix), zg(iz,ix)

  integer :: ns, ngmax
  integer, allocatable :: ng(:)
  real, allocatable :: xs(:), zs(:), xg(:,:), zg(:,:), t(:,:)
end type acquisition

type wavelet_param
  character(len=100) :: fileformat, inputprefix, outputprefix
  integer            :: ns, ng, nt, iref
  real               :: dx, dt, ds, dg
end type wavelet_param

end module datatype

